
/**
 * /!\ This file is automatically generated by QLALR from LogLexer.g.
 * /!\ Don't edit it!
 */

#ifndef LOGLEXER_HPP
#define LOGLEXER_HPP

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "PluginsGlobal.hpp"
#include "table_loglexer_p.h"

class SUGL_SHARED_EXPORT LogLexer : public LexerParser<Table_LogLexer>
{
	Q_OBJECT

public:
	LogLexer(QObject *parent = nullptr);
	virtual ~LogLexer() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		/** The date and time */
		Date,
		/** Type (debug, info...) */
		Type,
		/** Logged message */
		Content,
		/** For Debug, info on file where the log happened */
		FileInfo,
		// Flags
		Debug = 0x0008, // 8
		Info = 0x0010, // 16
		Warning = 0x0040, // 64
		Critical = 0x0080, // 128
		Fatal = Critical,
		Error = Critical,
		Unknown = -1
	};
	// implemented in LogLexer_impl.cpp
	virtual const char *language() const override { return "Log"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in LogLexer_impl.cpp
	virtual const std::string &getMIMEType() const override { static std::string _tmp = ""; return _tmp; }
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &) override { return std::string(); }
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &) override { return std::string(); }
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &) override { return std::string(); }
	virtual std::string write(const ShareablePosition &) override { return std::string(); }

protected:
	// LexerParser
	virtual bool startLexer(int start, int end) override;
	virtual void endLexer() override;

private:
	// LexerParser
	// generated in in LGCInputLexerIO_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;

private:
	Styles _currentTypeFlag = Styles::Unknown;
};

#endif // LOGLEXER_HPP
